> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List VMs

> Show all Team's Virtual Machines.




## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples get /virtual_machines
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /virtual_machines:
    get:
      tags:
        - Virtual machines
      summary: List VMs
      description: |
        Show all Team's Virtual Machines.
      operationId: index-virtual-machine
      parameters:
        - name: filter[project]
          in: query
          required: false
          description: The project ID or Slug to filter by
          schema:
            type: string
        - name: extra_fields[virtual_machines]
          in: query
          required: false
          description: >-
            The `credentials` are provided as extra attributes that are lazy
            loaded. To request it, just set
            `extra_fields[virtual_machines]=credentials` in the query string.
          examples:
            Success:
              value: credentials
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/vnd.api+json:
              examples:
                Success:
                  value:
                    data:
                      - id: vm_zlkg1DegdvZE5
                        type: virtual_machines
                        attributes:
                          name: my-new-vm
                          status: Running
                          created_at: '2026-01-14T15:57:14+00:00'
                          primary_ipv4: 192.168.1.100
                          credentials:
                            username: ubuntu
                            host: 192.168.1.100
                            password: secure_password
                            ssh_keys: []
                          operating_system: null
                          site: MEX192
                          billing: hourly
                          plan:
                            id: plan_059EqYVjDQj8p
                            name: g3.l40s.medium-142
                          specs:
                            vcpu: null
                            ram: null
                            storage: null
                            nic: 1 x 1 Gbps
                            gpu: 1 x NVIDIA H100 Tensor Core GPU
                          team:
                            id: team_1ejNe2b5gQiKpxYNxz0bFm2yY38
                            name: 701 Team
                            slug: 701-team
                            description: 701 Team
                            address: 29825 Klocko Trafficway, Wunschhaven, KS 74888
                            status: verified
                            currency:
                              id: cur_AW6Q2D9lqKLpr
                              code: BRL
                              name: Brazilian Real
                              currency_id: null
                          project:
                            id: proj_w49QDB2WDagKb
                            name: Intelligent Granite Pants
                            slug: intelligent-granite-pants
                            description: Aerodynamic Copper Bottle
                            billing_type: Normal
                            billing_method: Normal
                            bandwidth_alert: false
                            environment: null
                            billing:
                              subscription_id: null
                              type: Normal
                              method: Normal
                            stats:
                              databases: 0
                              ip_addresses: 0
                              prefixes: 0
                              servers: 0
                              storages: 0
                              virtual_machines: 1
                              vlans: 0
              schema:
                $ref: '#/components/schemas/virtual_machines'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                res = latitudesh.virtual_machines.list(extra_fields_virtual_machines="credentials")

                # Handle response
                print(res)
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.VirtualMachines.List(ctx, nil, latitudeshgosdk.Pointer(\"credentials\"))\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.VirtualMachines != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.virtualMachines.list({
                extraFieldsVirtualMachines: "credentials",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    virtual_machines:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/virtual_machine_attributes'
        meta:
          type: object
    virtual_machine_attributes:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - virtual_machines
        attributes:
          type: object
          properties:
            name:
              type: string
            created_at:
              type: string
            status:
              type: string
              enum:
                - Running
                - Configuring network
                - Starting
                - Scheduling
                - Scheduled
                - Destroying
            primary_ipv4:
              type: string
              nullable: true
            operating_system:
              type: object
              nullable: true
              description: The operating system installed on the virtual machine
              properties:
                name:
                  type: string
                  description: The full name of the operating system
                slug:
                  type: string
                  description: The unique slug identifier for the operating system
                version:
                  type: string
                  description: The version of the operating system
                features:
                  type: object
                  description: Features supported by this operating system
                  properties:
                    raid:
                      type: boolean
                      description: Whether RAID is supported
                    ssh_keys:
                      type: boolean
                      description: Whether SSH keys are supported
                    user_data:
                      type: boolean
                      description: Whether user data is supported
                distro:
                  type: object
                  description: Distribution information
                  properties:
                    name:
                      type: string
                      description: The name of the Linux distribution
                    slug:
                      type: string
                      description: The slug of the Linux distribution
                    series:
                      type: string
                      description: The distribution series code name
            credentials:
              type: object
              nullable: true
              properties:
                username:
                  type: string
                host:
                  type: string
                password:
                  type: string
                ssh_keys:
                  type: array
                  items:
                    type: string
            plan:
              type: object
              properties:
                id:
                  type: string
                name:
                  type: string
            specs:
              type: object
              properties:
                vcpu:
                  type: integer
                  nullable: true
                ram:
                  type: string
                  nullable: true
                storage:
                  type: string
                  nullable: true
                nic:
                  type: string
                  nullable: true
                gpu:
                  type: string
                  nullable: true
            team:
              $ref: '#/components/schemas/team_include'
            project:
              $ref: '#/components/schemas/project_include'
    team_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        address:
          type: string
        currency:
          type: object
        status:
          type: string
        feature_flags:
          type: array
          items:
            type: string
    project_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        billing_type:
          type: string
          nullable: true
        provisioning_type:
          type: string
          nullable: true
        billing_method:
          type: string
          nullable: true
        bandwidth_alert:
          type: boolean
        environment:
          type: string
          nullable: true
        billing:
          type: object
          properties:
            subscription_id:
              type: string
              nullable: true
            type:
              type: string
            method:
              type: string
        stats:
          type: object
          properties:
            ip_addresses:
              type: integer
            prefixes:
              type: integer
            servers:
              type: integer
            vlans:
              type: integer
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````